﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.WindowsAPICodePack.Shell;
namespace MP3
{
    class MP3
    {
        public class MP3Details
        {
            public Int32 length { get; set; }
            public TimeSpan time { get; set; }
            public String Artist { get; set; }
            public String Title { get; set; }
        }
        public static MP3Details GetMP3Details(String FilePath)
        {
            if (File.Exists(FilePath))
            {
                MP3Details oMP3 = new MP3Details();
                oMP3.length = 0;
                ShellFile Shellfile = ShellFile.FromFilePath(FilePath);

                String Duration = Shellfile.Properties.System.Media.Duration.ToString();
                if(Shellfile.Properties.System.Media.Duration.Value!=null){
                    UInt64 ulLength100NanoSeconds = 0;
                    if (UInt64.TryParse(Shellfile.Properties.System.Media.Duration.Value.ToString(), out ulLength100NanoSeconds))
                    {
                        oMP3.length = System.Convert.ToInt32(ulLength100NanoSeconds / 10000000);
                        oMP3.time = new TimeSpan(0, 0, oMP3.length);
                    }
                    
                }
                if (Shellfile.Properties.System.Music.Artist != null)
                {
                    oMP3.Artist = String.Join(" ",Shellfile.Properties.System.Music.Artist.Value);
                }
                else
                {
                    oMP3.Artist = "";
                }
                if (Shellfile.Properties.System.Title != null)
                {
                    oMP3.Title = Shellfile.Properties.System.Title.Value;
                }
                else
                {
                    oMP3.Title = "";
                }
                return (oMP3);
            }
            else
            {
                return null;
            }
        }
    }
}
