﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.IO;
using System.Xml;
using System.Drawing;

namespace Metadata
{
    class Metadata
    {
        public class AudioScrobbler
        {
            public static String ApiKey = "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";
            // {0} = Artist {1}=Title {2} = ApiKey
            public static String QueryURLGET = @"http://ws.audioscrobbler.com/2.0/?method=track.getInfo&artist={0}&track={1}&api_key={2}";
            public static String QueryURLPOST = @"https://ws.audioscrobbler.com/2.0";
            public static String PostDataFormat = @"method=track.getInfo&artist={0}&track={1}&api_key={2}";
            public static void QueryAudioScrobbler(Song.Song Song)
            {
                // HttpUtility
                // String Query = String.Format(QueryURLGET, System.Uri.EscapeUriString(Song.Artist), System.Uri.EscapeUriString(Song.Title), ApiKey);
                // String Query = String.Format(QueryURLGET, System.Uri.EscapeUriString(Song.Artist), System.Uri.EscapeUriString(Song.Title.Split(new char[] { '-' })[0]).Trim(), ApiKey);
                String Query = QueryURLPOST;
                String PostData = PostDataFormat;
                PostData = String.Format(PostData, System.Uri.EscapeUriString(Song.Artist.Trim()), System.Uri.EscapeUriString(Song.Title.Trim()), ApiKey);
                // PostData = String.Format(PostData, System.Uri.EscapeUriString(Song.Artist), System.Uri.EscapeUriString(Song.Title.Split(new char[] {'-'})[0].Trim()), ApiKey);
                byte[] aPostData= Encoding.ASCII.GetBytes(PostData);
                System.Diagnostics.Debug.WriteLine("Querying AudioScrobbler: " + Query); // + " Data:" + PostData);
                HttpWebRequest AudioScrobblerWebRequest = (HttpWebRequest)WebRequest.Create(Query);
                // AudioScrobblerWebRequest.Proxy = new System.Net.WebProxy("localhost", 5865);
                // Try to get some information 
                try
                {
                    // HTTP Post
                    AudioScrobblerWebRequest.Method = "POST";
                    AudioScrobblerWebRequest.Timeout = 10000;
                    AudioScrobblerWebRequest.ContentType = "application/x-www-form-urlencoded";
                    AudioScrobblerWebRequest.ContentLength = aPostData.Length;
                    Stream AudioScrobblerRequestStream = AudioScrobblerWebRequest.GetRequestStream();
                    AudioScrobblerRequestStream.Write(aPostData, 0, aPostData.Length);
                    AudioScrobblerRequestStream.Close();
					// Async http://stackoverflow.com/questions/8642745/httprequest-giving-parameter-to-asynccallback-delegate
                    AudioScrobblerWebRequest.BeginGetResponse(result =>
                    {
                        AsyncProcessWebResponse(result, AudioScrobblerWebRequest, Song);
                    }, null);
                    /*System.Net.HttpWebResponse WebResponse = (System.Net.HttpWebResponse)AudioScrobblerWebRequest.GetResponse();
                    System.IO.Stream WebStream= WebResponse.GetResponseStream();
                    XmlDocument XMLresponse = new XmlDocument();
                    XMLresponse.Load(WebStream);
                    XmlNode XMLLFM = XMLresponse.SelectSingleNode("/lfm");
                    if (XMLLFM.Attributes["status"].Value == "ok")
                    {
                        XmlNode XMLAlbumTitle =XMLresponse.SelectSingleNode("/lfm/track/album/title");
                        if(XMLAlbumTitle!=null)
                        {
                            System.Diagnostics.Debug.WriteLine("Audioscrobbler Album Title found: " + XMLAlbumTitle.InnerText);
                            Song.Album = XMLAlbumTitle.InnerText;
                        }
                        // small, medium, large,extralarge
                        XmlNode XMLAlbumImage = XMLresponse.SelectSingleNode(@"/lfm/track/album/image[@size=""extralarge""]");
                        if(XMLAlbumImage!=null)
                        {
                            System.Diagnostics.Debug.WriteLine("Audioscrobbler Album Image found: " + XMLAlbumImage.InnerText);
                            HttpWebRequest RequestImage = (HttpWebRequest)WebRequest.Create(XMLAlbumImage.InnerText);
                            HttpWebResponse ResponseImage = (HttpWebResponse)RequestImage.GetResponse();
                            if(ResponseImage!=null)
                            {
                                System.Diagnostics.Debug.WriteLine("Audioscrobbler Album Image download ok.");
                                String TempFileName = Path.GetTempPath()+ Path.GetFileNameWithoutExtension(Path.GetTempFileName())+".png";
                                System.Diagnostics.Debug.WriteLine("Audioscrobbler Save Album Image to " + TempFileName);
                                Image AlbumImage = Image.FromStream(ResponseImage.GetResponseStream());
                                Song.AlbumImage = AlbumImage;
                                AlbumImage.Save(TempFileName, System.Drawing.Imaging.ImageFormat.Png);
                                Song.AlbumImagePath = TempFileName;
                            }
                        }
                    }
                    else
                    {
                        System.Diagnostics.Debug.WriteLine("AudioScrobbler Response error: " + XMLLFM.Attributes["status"].Value);
                    }*/
                }
                catch (Exception e)
                {
                    System.Diagnostics.Debug.WriteLine("Error while querying AudioScrobbler occured: "+ e.Message);
                }
            }

            private static void ProcessWebResponse()
            {
                throw new NotImplementedException();
            }
        }
        public static void AsyncProcessWebResponse(IAsyncResult Result,HttpWebRequest request, Song.Song Song)
        {
            using (HttpWebResponse WebResponse = (HttpWebResponse)request.EndGetResponse(Result))
            {
                System.IO.Stream WebStream= WebResponse.GetResponseStream();
                XmlDocument XMLresponse = new XmlDocument();
                XMLresponse.Load(WebStream);
                XmlNode XMLLFM = XMLresponse.SelectSingleNode("/lfm");
                if (XMLLFM.Attributes["status"].Value == "ok")
                {
                    XmlNode XMLAlbumTitle =XMLresponse.SelectSingleNode("/lfm/track/album/title");
                    if(XMLAlbumTitle!=null)
                    {
                        System.Diagnostics.Debug.WriteLine("Audioscrobbler Album Title found: " + XMLAlbumTitle.InnerText);
                        Song.Album = XMLAlbumTitle.InnerText;
                    }
                    // small, medium, large,extralarge
                    XmlNode XMLAlbumImage = XMLresponse.SelectSingleNode(@"/lfm/track/album/image[@size=""extralarge""]");
                    if(XMLAlbumImage!=null)
                    {
                        System.Diagnostics.Debug.WriteLine("Audioscrobbler Album Image found: " + XMLAlbumImage.InnerText);
                        HttpWebRequest RequestImage = (HttpWebRequest)WebRequest.Create(XMLAlbumImage.InnerText);
                        HttpWebResponse ResponseImage = (HttpWebResponse)RequestImage.GetResponse();
                        if(ResponseImage!=null)
                        {
                            System.Diagnostics.Debug.WriteLine("Audioscrobbler Album Image download ok.");
                            String TempFileName = Path.GetTempPath()+ Path.GetFileNameWithoutExtension(Path.GetTempFileName())+".png";
                            System.Diagnostics.Debug.WriteLine("Audioscrobbler Save Album Image to " + TempFileName);
                            Image AlbumImage = Image.FromStream(ResponseImage.GetResponseStream());
                            Song.AlbumImage = AlbumImage;
                            AlbumImage.Save(TempFileName, System.Drawing.Imaging.ImageFormat.Png);
                            Song.AlbumImagePath = TempFileName;
                        }
                    }
                }
                else
                {
                    System.Diagnostics.Debug.WriteLine("AudioScrobbler Response error: " + XMLLFM.Attributes["status"].Value);
                }
            }
        }        
    }
}
