﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace Song
{
    class Song
    {
        public enum CONVERSATION_STATE : int { RECORDING = -10, RECORDING_FINSIHED=-9,CONVERTING_IN_PROGRESS = -8, DELETED = -7, CONVERT_ERROR = -6, FILE_EXISTS = -5 };
        public int SongID {get;set;}
        private String sArtist;
        public String Artist { get { return sArtist; } }
        private String sTitle;
        public String Title { get { return sTitle; } }
        public String Album { get; set; }
        public String AlbumImagePath { get; set; }
        public Image AlbumImage;
        private String sWorkingDirectory;
        public String WorkingDirectory
        {
            get {
                return sWorkingDirectory; 
            }
            set 
            { 
                    sWorkingDirectory = value;
                    sWavFilePath = String.Format("{0}\\{1} - {2}.wav", sWorkingDirectory, sArtist, sTitle);
                    sMP3FilePath = String.Format("{0}\\{1} - {2}.mp3", sWorkingDirectory, sArtist, sTitle);
            }
        }
        private String sWavFilePath;
        public String WavFilePath { get { return sWavFilePath; } }
        private String sMP3FilePath;
        public String MP3FilePath { get { return sMP3FilePath;  } }
        public String MP3FileName { 
            get { 
                return (new System.IO.FileInfo(sMP3FilePath)).Name;
            } 
        }
        public int CoversationState { get; set; }
        public int LameReturnCode { get; set; }
        public string CoversationStateMessage {
            get {
                if (CoversationState == (int)CONVERSATION_STATE.RECORDING)
                {
                    return "Recording";
                }
                else if (CoversationState == (int)CONVERSATION_STATE.RECORDING_FINSIHED)
                {

                    return "Recording finished";
                }
                else if (CoversationState == (int)CONVERSATION_STATE.CONVERTING_IN_PROGRESS)
                {

                    return "Converting started";
                }
                else if (CoversationState == (int)CONVERSATION_STATE.DELETED)
                {

                    return "Deleted";
                }
                else if (CoversationState == (int)CONVERSATION_STATE.CONVERT_ERROR)
                {

                    return "Converting error. Lame errorcode: ";
                }
                else if (CoversationState == (int)CONVERSATION_STATE.FILE_EXISTS)
                {

                    return "Already converted";
                }
                else if(CoversationState>=0 && CoversationState<=99 )
                {
                    return String.Format("Converting {0}%", CoversationState);
                }
                else if (CoversationState >= 100 && LameReturnCode == 0)
                {
                    return String.Format("Ok" );
                }
                else if (CoversationState >= 100 && LameReturnCode != 0)
                {
                    return String.Format("Error: "+LameReturnCode);
                }
                else
                {
                    return "Unknown";
                }
            }
        }
        public Song(String Artist, String Title)
        {
            this.CoversationState = (int)CONVERSATION_STATE.RECORDING;
            sArtist = Artist;
            sTitle = Title;
            sWorkingDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyMusic);
            sWavFilePath = String.Format("{0}\\{1} - {2}.wav", sWorkingDirectory, sArtist, sTitle);
            sMP3FilePath = String.Format("{0}\\{1} - {2}.mp3", sWorkingDirectory, sArtist, sTitle);
            LameReturnCode = -1;
            this.SongID = -1;
            AlbumImage = null;
        }
        public Song(String Artist,String Title, String WorkingDirectory)
        {
            this.CoversationState = -1;
            sArtist = Artist;
            sTitle = Title;
            if(String.IsNullOrEmpty(WorkingDirectory))
            {
                sWorkingDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyMusic);
            }
            else
            {
                sWorkingDirectory = WorkingDirectory;
            }
            sWavFilePath = String.Format("{0}\\{1} - {2}.wav", sWorkingDirectory, sArtist, sTitle);
            sMP3FilePath = String.Format("{0}\\{1} - {2}.mp3", sWorkingDirectory, sArtist, sTitle);
            LameReturnCode = -1;
            this.SongID = -1;
            AlbumImage = null;
        }
    }
}
